# -*- coding: utf-8 -*-
"""
Created on Sun Aug 04 10:05:26 2013

@author: Deyuan Zhang and Bin Liu
this file contains the utilities of reading the gist kernel file into the numpy
array format and save the numpy array into gist kernel file
"""

from numpy import *


def getMat(fname):
    """read the GIST format file into the numpy array.
    Input: 
        fname: the file name of the kernel file.
    Output: 
        mat: 2 dimentional numpy array."""
    mat = loadtxt(fname, skiprows = 1)
    mat = mat[:,1:]
    print fname
    print mat
    print mat.shape
    return mat

def saveMat(fname, mat):
    """save the numpy array into a GIST format file.
    Input: 
        fname: the file name of the kernel file.
        mat: 2 dimentional numpy array."""
    row,col = mat.shape
    f = open(fname, 'w')
    f.write('seq ')
    for i in range(col):
        f.write('%d\t'%(i+1,))
    f.write('\n')
    for i in range(row):
        f.write("%d\t"%(i+1,))
        for j in range(col):
            f.write('%e\t'%(mat[i,j],))
        f.write('\n')
    f.close()

def getLabel(fname):
    """get the labels of the gist file into python list"""
    mat = loadtxt(fname, skiprows = 1, usecols=(1,), dtype=int)
    result = mat.tolist()
    return result