#!/usr/bin/env python
#coding=utf-8
"""
@author: Deyuan Zhang and Bin Liu
this file contains the function of normalize the kernel matrix using equation 9
of the paper and the utilities of convert the kenrel matrix into the normalized
one.
"""


from numpy import *
import numpy
import sys
from gistutil import getMat, saveMat


def normalize(fname1, fname2, fname3, fname4):
    mattr  = getMat(fname1)
    matte = getMat(fname2)
    matlatr = loadtxt(fname3, skiprows = 1, usecols = (0,1))
    matlate = loadtxt(fname4, skiprows = 1, usecols = (0,1))
    matlate = matlate[:,1].reshape(-1,1)*matlatr[:,1].reshape(1,-1)
    matlatr = matlatr[:,1].reshape(-1,1)*matlatr[:,1].reshape(1,-1)
    matlatr = numpy.sqrt(matlatr)
    matlate = numpy.sqrt(matlate)
    mattr /= matlatr
    matte /= matlate
    saveMat(fname1, mattr)
    saveMat(fname2, matte)



if __name__ == '__main__':
    if len(sys.argv) != 20:
        print 'check your argument'
        print len(sys.argv)
        sys.exit()
    mtype = sys.argv[1]
    print mtype
    flname = sys.argv[2]    
    ftrainname1 = sys.argv[3]
    ftestname1 = sys.argv[4]    
    ftrainname2 = sys.argv[5]
    ftestname2 = sys.argv[6]    
    ftrainname3 = sys.argv[7]
    ftestname3 = sys.argv[8]
    ftrainname = sys.argv[9]
    ftestname = sys.argv[10]
    
    normalize( ftrainname1, ftestname1, sys.argv[11], sys.argv[12] )
    normalize( ftrainname2, ftestname2, sys.argv[13], sys.argv[14] )
    normalize( ftrainname3, ftestname3, sys.argv[15], sys.argv[16] )
        
    
